# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2013 credativ (http://www.credativ.co.uk). All Rights Reserved
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import osv, fields
#from openerp.tools.translate import _
import redmine_osv

class project(redmine_osv.redmine_osv):
    _inherit = 'project.project'

    _columns = {
        'redmine_id': fields.integer(
            'Redmine ID',
            readonly=True),
    }

project()


class task(redmine_osv.redmine_osv):
    _inherit = 'project.task'

    _columns = {
        'redmine_id': fields.integer(
            'Redmine ID',
            readonly=True),
    }

    def oevals_from_extdata(self, cr, uid, external_referential_id, data_record, mapping_lines, key_for_external_id=None,
                            parent_data=None, previous_lines=None, defaults=None, context=None):
        mapped_vals = super(task, self).oevals_from_extdata(cr, uid, external_referential_id, data_record, mapping_lines, key_for_external_id=key_for_external_id,
                                                            parent_data=parent_data, previous_lines=previous_lines, defaults=defaults, context=context)

        if mapped_vals.get('project_id', False):
            mapped_vals['project_id'] = self.get_oe_project(cr, uid, external_referential_id, mapped_vals['project_id'], context=context)
            if not mapped_vals['project_id']:
                mapped_vals.pop('project_id')

        if mapped_vals.get('user_id', False):
            mapped_vals['user_id'] = self.get_oe_user(cr, uid, mapped_vals['user_id'], context=context)
            if not mapped_vals['user_id']:
                mapped_vals.pop('user_id')

        return mapped_vals

task()


class project_work(redmine_osv.redmine_osv):
    _inherit = "project.task.work"

    _columns = {
        'redmine_id': fields.integer(
            'Redmine ID',
            readonly=True),
    }

    def oevals_from_extdata(self, cr, uid, external_referential_id, data_record, mapping_lines, key_for_external_id=None,
                            parent_data=None, previous_lines=None, defaults=None, context=None):
        mapped_vals = super(project_work, self).oevals_from_extdata(cr, uid, external_referential_id, data_record, mapping_lines, key_for_external_id=key_for_external_id,
                                                                    parent_data=parent_data, previous_lines=previous_lines, defaults=defaults, context=context)

        if mapped_vals.get('task_id', False):
            mapped_vals['task_id'] = self.get_oe_task(cr, uid, external_referential_id, mapped_vals['task_id'], context=context)
            if not mapped_vals['task_id']:
                mapped_vals.pop('task_id')

        if mapped_vals.get('user_id', False):
            mapped_vals['user_id'] = self.get_oe_user(cr, uid, mapped_vals['user_id'], context=context)
            if not mapped_vals['user_id']:
                mapped_vals.pop('user_id')

        return mapped_vals

    def create(self, cr, uid, vals, *args, **kwargs):
        import ipdb; ipdb.set_trace()
        task_pool = self.pool.get('project.task')
        #if 'task_id' not in vals:
            ## FIXME: vals['name'] is NOT project task name
            #tasks = task_pool.search(cr,uid,[('name','=',vals['name'])]) # FIXME: add check of project as well, for cases where several projects have a task with the same name
            #if not tasks:
                ## NOTE: If a RM issue has been closed before the first import then it will not be imported.
                #raise osv.except_osv('No Task Detected',
                                    #'Please import RM issues first.')
            #else:
                #vals['task_id'] = tasks[0]
        if 'hours' in vals:
            task_browse = task_pool.browse(cr,uid,vals.get('task_id',[]))
            rm_user_id = vals.get('user_id',False)
            user_ids = self.pool.get('res.users').search(cr,uid,[('rm_user_id','=',rm_user_id)])
            # NOTE: number of user_ids that have the same rm_user_id should never be more than 1
            if user_ids and task_browse and task_browse.project_id and task_browse.project_id.analytic_account_id and task_browse.project_id.analytic_account_id.id or False:
                timesheet_vals = {}
                timesheet_vals['account_id'] = task_browse.project_id.analytic_account_id.id
                employee_pool = self.pool.get('hr.employee')
                employee_id = employee_pool.search(cr,uid,[('id','=',user_ids[0])])[0] or False
                timesheet_vals['name'] = vals.get('name','')
                timesheet_vals['user_id'] = user_ids[0]
                timesheet_vals['date'] = vals.get('date',False) # FIXME: what default date should this be if 'date' isn't set in vals?
                timesheet_vals['product_id'] = employee_pool.browse(cr,uid,employee_id)['product_id'].id
                #timesheet_vals['amount'] = -30 # FIXME: linked to project?
                #timesheet_vals['general_account'] = 23 # FIXME: linked to project?
                timesheet_vals['journal_id'] = employee_pool.browse(cr,uid,employee_id)['journal_id'].id
                timesheet_vals['redmine_id'] = vals.get('task_id',False)
                timesheet_vals['product_uom_id'] = self.pool.get('product.uom').search(cr,uid,[('name','=','Hour')])[0]
                timesheet_vals['unit_amount'] = vals.get('hours',0.0)
                hr_timesheet_pool = self.pool.get('hr.analytic.timesheet')
                hr_timesheet_pool.create(cr, uid,timesheet_vals)
            #else: # FIXME: Display message to user that rm_user, task, project or analytic account not defined.
        return super(project_work,self).create(cr, uid, vals, *args, **kwargs)

    def write(self, cr, uid, ids, vals, context=None):
        import ipdb; ipdb.set_trace()
        if isinstance(ids, (int, long)):
            ids = [ids]
        return super(project_work,self).write(cr, uid, ids, vals, context)

    #def unlink(self, cr, uid, ids, *args, **kwargs):
        #import ipdb; ipdb.set_trace()
        #return super(project_work,self).unlink(cr, uid, ids,*args, **kwargs)
        
project_work()
